import wx
import usb


VENDOR_RQ_SET_LED    = 0
VENDOR_RQ_GET_SWITCH = 1
VENDOR_RQ_GET_LIGHT = 2

def find_board():
    board = None
    for bus in usb.busses():
        for dev in bus.devices:
            if dev.idVendor == 0x16c0 and dev.idProduct == 0x05dc:
                return dev
    return None

board = find_board()
handle = board.open()
req = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN

class HelloWorld(wx.Frame):
	def __init__(self):
		wx.Frame.__init__(self,None, wx.ID_ANY,'Battery Checker')

		#self.helloButton.Bind(wx.EVT_BUTTON, self.doSomethings)

		self.helloButton = wx.Button(self,label="Click Here To Read Voltage !!")
		self.helloButton.size = (10,30)
		self.helloButton.Bind(wx.EVT_BUTTON, self.doSomething)
		self.Show(True)

	def doSomething(self,event):
		req = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN
		val = handle.controlMsg(req,2,10)
		vol = float((val[0] + (val[1]*256)))/1023*5
		vol *=2
		self.helloButton.SetLabel("Battery Voltage is "+str("%.2f" % (vol))+ " V.")

application = wx.PySimpleApp()
window = HelloWorld()
application.MainLoop()

