import usb
import os

VENDOR_RQ_SET_LED    = 0
VENDOR_RQ_GET_SWITCH = 1
VENDOR_RQ_GET_LIGHT = 2

def find_board():
    board = None
    for bus in usb.busses():
        for dev in bus.devices:
            if dev.idVendor == 0x16c0 and dev.idProduct == 0x05dc:
                return dev
    return None

def welcome ():
	print "--------------------------------------"
	print "|      Welcome to Battery Checker    |"
	print "--------------------------------------"	
	print "Please Enter Your Battery Voltage : ",
	input = float(raw_input())
	return input

def manu () :	
	print "--------------------------------------"
	print "|              Main Manu             |"
	print "--------------------------------------"
	print "1. Set LED"
	print "2. Read Switch Status"
	print "3. Read Voltage level of Battery"
	print "4. Quit!!!"
	print "--------------------------------------"	
	print "Enter Choice : " ,
	choice = int(raw_input())
	return choice

choice = 0
board = find_board()
handle = board.open()
req = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN
input = 0
input = welcome()
os.system('clear')
while(True):
	if(input!= 0 and choice != 4) :
		choice = manu()
	if (choice == 1) :
		print "Enter LED no(0-2) : ",
		led_no = int(raw_input())
		print "Turn it on or off  : ",
		led_sta = int(raw_input())
		led_sta |= 0x0000
		led_sta = led_sta << 8	
		led_sta |= led_no		
		value = led_sta
		print value
		req = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_OUT
		led = handle.controlMsg(req,0,None,value)
	elif (choice == 2) :
		req = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN
		sw = handle.controlMsg(req,1,1)
		if (sw[0]) :
			print "The switch is currently on"
		else :
			print "The switch is currently off"
	elif (choice == 3) :
		req = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN
		val = handle.controlMsg(req,2,10)
		vol = float((val[0] + (val[1]*256)))/1023*5
		vol *=2
		print "The voltage :",
		print "%.2f" % (vol),
		print " V."

	if (choice == 4) :
		break
